<?php

class DispletRetsIdxAdminPagesController extends DispletRetsIdxAdminPagesModel {
	public static function build() {
		self::build_model();
		self::maybe_build_page();
	}

	public static function include_javascript_variables(){
		echo DispletRetsIdxTemplatesController::get_template( 'displet-admin-javascript-variables.php', self::$_model );
	}

	private static function maybe_build_page() {
		if ( self::$_model['is_lead_manager_page'] ) {
			DispletRetsIdxLeadManagerPageController::build();
		}
		else if ( self::$_model['is_saved_properties_page'] ) {
			DispletRetsIdxSavedPropertiesPageController::build();
		}
		else if ( self::$_model['is_saved_searches_page'] ) {
			DispletRetsIdxSavedSearchesPageController::build();
		}
	}

	public static function maybe_clean_up_dashboard() {
		if ( ( current_user_can( self::$_capabilities['save_property'] ) || current_user_can( self::$_capabilities['save_search'] ) ) && !current_user_can( 'manage_options' ) ) {
			remove_meta_box( 'dashboard_activity', 'dashboard', 'side' );
			remove_meta_box( 'dashboard_primary', 'dashboard', 'side' );
			remove_meta_box( 'dashboard_secondary', 'dashboard', 'side' );
		}
	}
}

?>