<?php

/*
 * Plugin name: Displet RETS/IDX
 * Plugin URI: http://displet.com/wordpress-plugins/displetreader-wordpress-plugin
 * Description: RETS/IDX Plugin that inserts real estate listings, statistics, maps, and quick searches into Wordpress pages & widget ready sidebars. Free version available.
 * Version: 2.0.52
 * Author: Displet
 * Author URI: http://displet.com/
 * License: GPL2
 */

class DispletRetsIdxPlugin {
	protected static $_api_url = 'http://api.displet.com';
	protected static $_capabilities = array(
		'save_property' => 'displet_save_properties',
		'save_search' => 'displet_save_searches',
		'view_leads' => 'displet_view_leads',
	 );
	protected static $_dir;
	public static $file = __FILE__;
	protected static $_field_options;
	protected static $_options;
	protected static $_roles = array(
		'lead' => 'displet_user',
		'agent' => 'displet_agent',
	 );
	protected static $_slug = 'displetreader-wordpress-plugin';
	protected static $_slugs = array(
		'lead_manager_page' => 'displet-lead-manager',
		'options' => array(
			'action' => 'displet_rets_idx_action_options',
			'fields' => 'displet_rets_idx_field_options',
			'notify' => 'displet_rets_idx_version',
			'settings' => 'displet_rets_idx_options',
			'version' => 'displet_rets_idx_plugin',
		),
		'property_showcase_cpt' => 'displet_prop_shwcase',
		'saved_properties_page' => 'displetretsidx_saved_properties',
		'saved_searches_page' => 'displetretsidx_saved_searches',
		'shortcode' => 'DispletListing',
	 );
	protected static $_url;
	protected static $_urls;
	protected static $_version = '2.0.52';

	public static function build() {
		self::set_directory();
		self::set_url();
		self::set_urls();
	}

	private static function set_directory() {
		self::$_dir = dirname( __FILE__ );
	}

	private static function set_url() {
		self::$_url = plugins_url( self::$_slug );
	}

	private static function set_urls() {
		self::$_urls = array(
			'css' => self::$_url . '/includes/css',
			'js' => self::$_url . '/includes/js',
		 );
	}
}

require_once( 'displet-requires.php' );
require_once( 'displet-admin-requires.php' );

?>