<?php

class DispletRetsIdxSearchFieldWidgetModel extends DispletRetsIdxPlugin {
	public static $fields = array(
		'acres_min' => array (
			'title' => 'Acres - Min',
			'label' => 'Min Acres',
		),
		'area_mls_defined_select' => array (
			'title' => 'Area ( MLS Defined )',
			'label' => 'Area',
		),
		'area_mls_defined' => array (
			'title' => 'Area ( MLS Defined ) | Multi-Select',
			'label' => 'Area',
		),
		'basement' => array (
			'title' => 'Basement',
			'label' => 'Basement',
		),
		'baths' => array (
			'title' => 'Baths - Min',
			'label' => 'Min Baths',
			'non_idx' => true,
		),
		'baths_max' => array (
			'title' => 'Baths - Max',
			'label' => 'Max Baths',
		),
		'beds' => array (
			'title' => 'Beds - Min',
			'label' => 'Min Beds',
			'non_idx' => true,
		),
		'beds_max' => array (
			'title' => 'Beds - Max',
			'label' => 'Max Beds',
		),
		'beds_baths' => array (
			'title' => 'Beds/Baths',
			'non_idx' => true,
		),
		'city_select' => array (
			'title' => 'City',
			'label' => 'City',
			'non_idx' => true,
		),
		'city' => array (
			'title' => 'City | Multi-Select',
			'label' => 'City',
			'non_idx' => true,
		),
		'county' => array (
			'title' => 'County',
			'label' => 'County',
		),
		'foreclosure' => array (
			'title' => 'Foreclosure',
			'label' => 'Foreclosure',
			'non_idx' => true,
		),
		'is_gated_community' => array (
			'title' => 'Gated Community',
			'label' => 'Gated Community',
		),
		'keywords' => array (
			'title' => 'Keywords',
			'label' => 'Keywords: Ex. Pool, Modern, Foreclosure',
			'non_idx' => true,
		),
		'listed_since' => array (
			'title' => 'List Date',
			'label' => 'List Date',
		),
		'last_modified' => array (
			'title' => 'Listing Updated',
			'label' => 'Listing Updated',
		),
		'master_on_main' => array (
			'title' => 'Master On Main',
			'label' => 'Master On Main',
		),
		'mls_number' => array (
			'title' => 'MLS Number',
			'label' => 'MLS&reg; Number',
		),
		'new_construction' => array (
			'title' => 'New Construction',
			'label' => 'New Construction',
		),
		'pool' => array (
			'title' => 'Pool',
			'label' => 'Pool',
			'non_idx' => true,
		),
		'price_min' => array (
			'title' => 'Price - Min',
			'label' => 'Min Price',
			'non_idx' => true,
		),
		'price_max' => array (
			'title' => 'Price - Max',
			'label' => 'Max Price',
			'non_idx' => true,
		),
		'price' => array (
			'title' => 'Price - Min/Max',
			'non_idx' => true,
		),
		'property_type_select' => array (
			'title' => 'Property Type',
			'label' => 'Property Type',
			'non_idx' => true,
		),
		'property_type' => array (
			'title' => 'Property Type | Multi-Select',
			'label' => 'Property Type',
			'non_idx' => true,
		),
		'quick_terms' => array (
			'title' => 'Quick Terms',
			'label' => 'City, Zip, Neighborhood, or Condo',
			'non_idx' => true,
		),
		'school' => array (
			'title' => 'School',
			'label' => 'School',
		),
		'school_district_select' => array (
			'title' => 'School District',
			'label' => 'School District',
		),
		'school_district' => array (
			'title' => 'School District | Multi-Select',
			'label' => 'School District',
		),
		'short_sale' => array (
			'title' => 'Short Sale',
			'label' => 'Short Sale',
		),
		'square_feet_min' => array (
			'title' => 'Square Feet - Min',
			'label' => 'Min Sq Ft',
			'non_idx' => true,
		),
		'square_feet_max' => array (
			'title' => 'Square Feet - Max',
			'label' => 'Max Sq Ft',
			'non_idx' => true,
		),
		'square_feet' => array (
			'title' => 'Square Feet - Min/Max',
			'non_idx' => true,
		),
		'status_select' => array (
			'title' => 'Status',
			'label' => 'Status',
		),
		'status' => array (
			'title' => 'Status | Multi-Select',
			'label' => 'Status',
		),
		'stories' => array (
			'title' => 'Stories',
			'label' => 'Stories',
		),
		'subdivision' => array (
			'title' => 'Subdivision',
			'label' => 'Subdivision',
			'non_idx' => true,
		),
		'waterfront' => array (
			'title' => 'Waterfront',
			'label' => 'Waterfront',
		),
		'year_built' => array (
			'title' => 'Year Built',
			'label' => 'Year Built',
		),
		'zip' => array (
			'title' => 'Zip Code',
			'label' => 'Zip Code',
			'non_idx' => true,
		),
	);

	private static function get_acres_options() {
		$options = array(
			'min' => array(),
		);
		if ( !empty( self::$_options['search_values_min_acres'] ) && !empty( self::$_options['search_values_max_acres'] ) && !empty( self::$_options['search_values_acres_increment'] ) ) {
			$min = floatval( self::$_options['search_values_min_acres'] );
			$max = floatval( self::$_options['search_values_max_acres'] );
			$increment = floatval( self::$_options['search_values_acres_increment'] );
			for ( $i = $min; $i <= $max; $i += $increment ) {
				$label = number_format( $i, 2 ) . '+ acres';
				$options['min'][ strval( $i ) ] = $label;
			}
		}
		return $options;
	}

	protected static function get_acres_min( $title ) {
		$options = self::get_acres_options();
		return self::get_select_markup( 'min_acres', $title, $options['min'] );
	}


	protected static function get_area_mls_defined( $title, $multiple = false ) {
		$options = self::get_area_mls_defined_options();
		if ( !empty( $options ) ) {
			return self::get_select_markup( 'area_mls_defined', $title, $options, $multiple );
		}
		else{
			return self::get_input_markup( 'area_mls_defined', $title );
		}
	}

	private static function get_area_mls_defined_options() {
		if ( !empty( self::$_options['displet_app_key'] ) && !empty( self::$_field_options['area_mls_defined'] ) ) {
			$options = array();
			foreach ( self::$_field_options['area_mls_defined'] as $area_mls_defined ) {
				$options[ $area_mls_defined ] = $area_mls_defined;
			}
			return $options;
		}
		return false;
	}

	protected static function get_basement( $title ) {
		return self::get_radio_markup( 'basement', $title, self::get_yes_no_any_options() );
	}

	protected static function get_baths( $title ) {
		$options = self::get_baths_options();
		return self::get_select_markup( 'min_bathrooms', $title, $options['min'] );
	}

	protected static function get_baths_max( $title ) {
		$options = self::get_baths_options();
		return self::get_select_markup( 'max_bathrooms', $title, $options['max'] );
	}

	private static function get_baths_options() {
		$options = array(
			'min' => array(),
			'max' => array(),
		);
		for ( $i=intval( self::$_options['search_values_baths_min'] ); $i <= intval( self::$_options['search_values_baths_max'] ); $i++ ) {
			$min_label = $i . '+ baths';
			$max_label = $i . '- baths';
			$options['min'][ $i ] = $min_label;
			$options['max'][ $i ] = $max_label;
		}
		return $options;
	}

	protected static function get_beds( $title ) {
		$options = self::get_beds_options();
		return self::get_select_markup( 'min_bedrooms', $title, $options['min'] );
	}

	protected static function get_beds_baths( $title ) {
		$beds_options = self::get_beds_options();
		$baths_options = self::get_baths_options();
		$beds_markup = self::get_select_markup( 'min_bedrooms', 'Min Beds', $beds_options['min'] );
		$baths_markup = self::get_select_markup( 'min_bathrooms', 'Min Baths', $baths_options['min'] );
		return self::get_or_markup( $beds_markup, $baths_markup );
	}

	protected static function get_beds_max( $title ) {
		$options = self::get_beds_options();
		return self::get_select_markup( 'max_bedrooms', $title, $options['max'] );
	}

	private static function get_beds_options() {
		$options = array(
			'min' => array(),
			'max' => array(),
		);
		for ( $i=intval( self::$_options['search_values_beds_min'] ); $i <= intval( self::$_options['search_values_beds_max'] ); $i++ ) {
			$min_label = $i . '+ beds';
			$max_label = $i . '- beds';
			$options['min'][ $i ] = $min_label;
			$options['max'][ $i ] = $max_label;
		}
		return $options;
	}

	protected static function get_city( $title, $multiple = false ) {
		$options = self::get_city_options();
		if ( !empty( $options ) ) {
			return self::get_select_markup( 'city', $title, $options, $multiple );
		}
		else{
			return self::get_input_markup( 'city', $title );
		}
	}

	private static function get_city_options() {
		if ( !empty( self::$_options['displet_app_key'] ) &&  !empty( self::$_field_options['city'] ) ) {
			$options = array();
			if ( !empty( self::$_options['city_include_filter'] ) ) {
				$city_filter = array_filter( self::$_options['city_include_filter'], array( 'DispletRetsIdxUtilities', 'remove_false_as_string' ) );
			}
			foreach ( self::$_field_options['city'] as $city_key => $city_value ) {
				if ( !empty( $city_filter ) && self::$_options['city_include_filter'][$city_value] != 'true' ) {
				}
				else{
					$city = trim( $city_value );
					$options[ $city ] = $city;
				}
			}
			return $options;
		}
		return false;
	}

	protected static function get_county( $title ) {
		return self::get_input_markup( 'county', $title );
	}

	protected static function get_foreclosure( $title ) {
		return self::get_radio_markup( 'is_foreclosure', $title, self::get_yes_no_any_options() );
	}

	protected static function get_is_gated_community( $title ) {
		return self::get_radio_markup( 'is_gated_community', $title, self::get_yes_no_any_options() );
	}

	private static function get_input_markup( $search_field, $title ) {
		return
			'<input type="text" id="displet-' . $search_field . '" name="' . $search_field . '" class="displet-search-field displet-full" value="" placeholder="' . $title . '">';
	}

	protected static function get_keywords( $title ) {
		return self::get_input_markup( 'keyword', $title );
	}

	protected static function get_last_modified( $title ) {
		return self::get_select_markup( 'last_modified', $title, self::get_last_modified_listed_since_options() );
	}

	private static function get_last_modified_listed_since_options() {
		return array(
			'1' => 'Last Day',
			'2' => 'Last 2 Days',
			'3' => 'Last 3 Days',
			'5' => 'Last 5 Days',
			'7' => 'Last Week',
			'30' => 'Last Month',
			'90' => 'Last 3 Months',
			'180' => 'Last 6 Months',
		);
	}

	protected static function get_listed_since( $title ) {
		return self::get_select_markup( 'listed_since', $title, self::get_last_modified_listed_since_options() );
	}

	protected static function get_master_on_main( $title ) {
		return self::get_radio_markup( 'master_on_main', $title, self::get_yes_no_any_options() );
	}

	protected static function get_mls_number( $title ) {
		return self::get_input_markup( 'mls_number', $title );
	}

	protected static function get_new_construction( $title ) {
		return self::get_radio_markup( 'is_new_construction', $title, self::get_yes_no_any_options() );
	}

	private static function get_or_markup( $first_half, $second_half, $to = false ) {
		$markup =
			'<div class="displet-or">';
		if ( $to ) {
			$markup .=
				'<span class="displet-to">
					To
				</span>';
		}
		$markup .=
				'<div class="displet-group">
					<div class="displet-half displet-left">
						' . $first_half . '
					</div>
					<div class="displet-half displet-right">
						' . $second_half . '
					</div>
				</div>
			</div>';
		return $markup;
	}

	protected static function get_pool( $title ) {
		return self::get_radio_markup( 'pool_on_property', $title, self::get_yes_no_any_options() );
	}

	protected static function get_price( $title ) {
		$options = self::get_price_options();
		$min_price_markup = self::get_select_markup( 'min_list_price', 'Min Price', $options['min'] );
		$max_price_markup = self::get_select_markup( 'max_list_price', 'Max Price', $options['max'] );
		return self::get_or_markup( $min_price_markup, $max_price_markup, true );
	}

	protected static function get_price_min( $title ) {
		$options = self::get_price_options();
		return self::get_select_markup( 'min_list_price', $title, $options['min'] );
	}

	protected static function get_price_max( $title ) {
		$options = self::get_price_options();
		return self::get_select_markup( 'max_list_price', $title, $options['max'] );
	}

	private static function get_price_options() {
		$options = array(
			'min' => array(),
			'max' => array(),
		);
		if ( !empty( self::$_options['search_values_custom_prices'] ) ) {
			$prices = array_filter( array_map( 'trim', explode( "\n", self::$_options['search_values_custom_prices'] ) ), 'is_numeric' );
		}
		else{
			$prices = array();
			for ( $i=intval( self::$_options['search_values_min_price'] ); $i <= intval( self::$_options['search_values_max_price'] ); $i+=intval( self::$_options['search_values_price_increment'] ) ) {
				if ( ( !empty( self::$_options['min_price_filter'] ) && $i < intval( self::$_options['min_price_filter'] ) ) || ( !empty( self::$_options['max_price_filter'] ) && $i > intval( self::$_options['max_price_filter'] ) ) ) {
				}
				else{
					$prices[] = $i;
				}
			}
		}
		if ( !empty( $prices ) ) {
			foreach ( $prices as $price ) {
				$base = '$' . number_format( $price * 1000 );
				$min_label = $base . '+';
				$max_label = $base . '-';
				$options['min'][ $price ] = $min_label;
				$options['max'][ $price ] = $max_label;
			}
		}
		return $options;
	}

	protected static function get_property_type( $title, $multiple = false ) {
		return self::get_select_markup( 'property_type', $title, self::get_property_type_options(), $multiple );
	}

	private static function get_property_type_options() {
		$options = array();
		if ( !empty( self::$_options['search_values_property_types'] ) ) {
			if ( !empty( self::$_options['property_type_include_filter'] ) ) {
				$property_type_filter = array_filter( self::$_options['property_type_include_filter'], array( 'DispletRetsIdxUtilities', 'remove_false_as_string' ) );
			}
			foreach ( self::$_options['search_values_property_types'] as $property_type_key => $property_type_value ) {
				if ( $property_type_value == 'true' ) {
					if ( !empty( $property_type_filter ) && self::$_options['property_type_include_filter'][$property_type_key] != 'true' ) {
					}
					else{
						$property_type = trim( $property_type_key );
						$options[ $property_type ] = $property_type;
					}
				}
			}
		}
		return $options;
	}

	protected static function get_quick_terms( $title ) {
		return self::get_input_markup( 'quick_terms', $title );
	}

	private function get_radio_markup( $search_field, $title, $options ) {
		$markup =
			'<div id="displet-' . $search_field . '" class="displet-radio">
				<label>' . $title . '</label>';
		if ( !empty( $options ) && is_array( $options ) ) {
			foreach ( $options as $value => $label ) {
				$markup .=
					'<input type="radio" name="' . $search_field . '" class="displet-search-field" value="' . $value . '">
					<span>
						' . $label . '
					</span>';
			}
		}
		$markup .=
			'</div>';
		return $markup;
	}

	private function get_select_markup( $search_field, $title, $options, $multiple = false ) {
		$markup = '';
		if ( !$multiple ) {
			$markup .=
				'<div class="displet-select">';
		}
		$markup .=
					'<select id="displet-' . $search_field . '" name="' . $search_field . '" class="displet-search-field"';
		if ( $multiple ) {
			$markup .= ' multiple data-placeholder="' . $title . '">';
		}
		else {
			$markup .= '>
						<option value="none" selected="selected">' . $title . '</option>';
		}
				if ( !empty( $options ) && is_array( $options ) ) {
					foreach ( $options as $value => $label ) {
						$markup .= '<option value="' . $value . '">' . $label . '</option>';
					}
				}
		$markup .=
					'</select>';
		if ( !$multiple ) {
			$markup .=
				'</div>';
		}
		return $markup;
	}

	protected static function get_school( $title ) {
		return self::get_input_markup( 'school', $title );
	}

	protected static function get_school_district( $title, $multiple = false ) {
		$options = self::get_school_district_options();
		if ( !empty( $options ) ) {
			return self::get_select_markup( 'school_district', $title, $options, $multiple );
		}
		else{
			return self::get_input_markup( 'school_district', $title );
		}
	}

	private static function get_school_district_options() {
		if ( !empty( self::$_options['displet_app_key'] ) && !empty( self::$_field_options['school_district'] ) ) {
			$options = array();
			foreach ( self::$_field_options['school_district'] as $school_district ) {
				$options[ $school_district ] = $school_district;
			}
			return $options;
		}
		return false;
	}

	protected static function get_short_sale( $title ) {
		return self::get_radio_markup( 'short_sale', $title, self::get_yes_no_any_options() );
	}

	protected static function get_square_feet( $title ) {
		$options = self::get_square_feet_options();
		$min_square_feet_markup = self::get_select_markup( 'min_square_feet', 'Min Sq Ft', $options['min'] );
		$max_square_feet_markup = self::get_select_markup( 'max_square_feet', 'Max Sq Ft', $options['max'] );
		return self::get_or_markup( $min_square_feet_markup, $max_square_feet_markup, true );
	}

	protected static function get_square_feet_min( $title ) {
		$options = self::get_square_feet_options();
		return self::get_select_markup( 'min_square_feet', $title, $options['min'] );
	}

	protected static function get_square_feet_max( $title ) {
		$options = self::get_square_feet_options();
		return self::get_select_markup( 'max_square_feet', $title, $options['max'] );
	}

	private function get_square_feet_options() {
		$options = array(
			'min' => array(),
			'max' => array(),
		);
		for ( $i = intval( self::$_options['search_values_min_square_feet'] ); $i <= intval( self::$_options['search_values_max_square_feet'] ); $i += intval( self::$_options['search_values_square_feet_increment'] ) ) {
			$square_feet = number_format( $i );
			$min_label = $square_feet . '+ sq ft';
			$max_label = $square_feet . '- sq ft';
			$options['min'][ $i ] = $min_label;
			$options['max'][ $i ] = $max_label;
		}
		return $options;
	}

	protected static function get_status( $title, $multiple = false ) {
		$options = self::get_status_options();
		if ( !empty( $options ) ) {
			return self::get_select_markup( 'status', $title, $options, $multiple );
		}
		else{
			return self::get_input_markup( 'status', $title );
		}
	}

	private static function get_status_options() {
		if ( !empty( self::$_options['displet_app_key'] ) && !empty( self::$_field_options['status'] ) ) {
			$options = array();
			foreach ( self::$_field_options['status'] as $status ) {
				$options[ $status ] = $status;
			}
			return $options;
		}
		return false;
	}

	protected static function get_stories( $title ) {
		return self::get_radio_markup( 'min_stories', $title, array(
			'1' => '1+',
			'2' => '2+',
			'none' => 'Any',
		) );
	}

	protected static function get_subdivision( $title ) {
		return self::get_input_markup( 'subdivision', $title );
	}

	protected static function get_waterfront( $title ) {
		return self::get_radio_markup( 'waterfront', $title, self::get_yes_no_any_options() );
	}

	protected static function get_year_built( $title ) {
		return self::get_select_markup( 'year_built', $title, array(
			'2' => 'New Construction',
			'5' => 'Last 5 Years',
			'10' => 'Last 10 Years',
			'15' => 'Last 15 Years',
			'20' => 'Last 20 Years',
			'25' => 'Last 25 Years',
		) );
	}

	private static function get_yes_no_any_options() {
		return array(
			'Y' => 'Yes',
			'N' => 'No',
			'none' => 'Any',
		);
	}

	protected static function get_zip( $title ) {
		return self::get_input_markup( 'zip', $title );
	}

}

?>